/* -*-C-*- elefunt.h */

/* Header file for Cody & Waite Elementary Function Test Package -- C Version */
/* Only this file needs to be #include'd by other files in the test package. */
/* See README file for details. */

#include <stdio.h>
#include <math.h>
#include <errno.h>
extern int errno;			/* maybe "int errno" at your site */

#ifdef MSC
#include <float.h>			/* need for _control87() in machar.c */
#endif

#ifdef __TURBOC__
#include <float.h>			/* need for _control87() in machar.c */
#endif


#define ONE 1.0
#define ZERO 0.0
#define TWO 2.0
#define TEN 10.0


#ifdef VMS

#ifndef EXIT_FAILURE
#define EXIT_FAILURE	((1 << 28) + 2) /* (suppresses %NONAME-E-NOMSG) */
#endif /* EXIT_FAILURE */

#ifndef EXIT_SUCCESS
#define EXIT_SUCCESS	(1)
#endif /* EXIT_SUCCESS */

#else /* NOT VMS */

#ifndef EXIT_FAILURE
#define EXIT_FAILURE	(1)
#endif /* EXIT_FAILURE */

#ifndef EXIT_SUCCESS
#define EXIT_SUCCESS	(0)
#endif /* EXIT_SUCCESS */

#endif /* VMS */


#ifdef PCC_20
typedef int void;
#endif

#ifdef __STDC__
#define ARGS(parenthesized_list) parenthesized_list
#define VOIDP			void*

#else  /* NOT STDC */
/* Provide some synonyms for new ANSI C features */

#ifdef __GNUC__			/* GNU gcc supports ANSI prototypes */
#define ARGS(parenthesized_list) parenthesized_list
#else
#ifdef ardent			/* Ardent cc supports ANSI prototypes */
#define ARGS(parenthesized_list) parenthesized_list
#else
#define ARGS(parenthesized_list) ()
#endif /* ardent */
#endif /* __GNUC__ */
#endif /* __STDC__ */

extern void	machar ARGS((int* ibeta, int* it, int* irnd, int* ngrd,
			int* machep, int* negep, int* iexp, int* minexp,
			int* maxexp, float* eps, float* epsneg,
			float* xmin, float* xmax));
extern float	randl ARGS((float x));
extern float	ran ARGS((int k));

#if 0
/* This is lacking on most systems */
extern double	cotan ARGS((void));
#else
#define cotan(x) (ONE/tan(x))		/* not defined in most C libraries */
#endif

extern double	ipow ARGS((double x, int n));
extern void	talog ARGS((void));
extern void	tasin ARGS((void));
extern void	tatan ARGS((void));
extern void	texp ARGS((void));
extern void	tpower ARGS((void));
extern void	tsin ARGS((void));
extern void	tsinh ARGS((void));
extern void	tmacha ARGS((void));
extern void	tsqrt ARGS((void));
extern void	ttan ARGS((void));
extern void	ttanh ARGS((void));

#ifdef abs
#undef abs
#endif
#define abs(x) (((x) < 0) ? -(x) : (x))

#ifdef ABS
#undef ABS
#endif
#define ABS(x) (((x) < 0) ? -(x) : (x))

#define AINT(x) ((float)((int)(x)))

#define alog(x) log(x)
#define ALOG(x) log(x)

#define alog10(x) log10(x)
#define ALOG10(x) log10(x)

#define amax1(x,y) (((x) >= (y)) ? (x) : (y))
#define AMAX1(x,y) (((x) >= (y)) ? (x) : (y))

#define amin1(x,y) (((x) <= (y)) ? (x) : (y))
#define AMIN1(x,y) (((x) <= (y)) ? (x) : (y))

#define DBLE(x) ((double)(x))

#define DOUBLE(x) ((double)(x))

#define FLOAT(x) ((float)(x))

#define iabs(x) (((x) < 0) ? -(x) : (x))
#define IABS(x) (((x) < 0) ? -(x) : (x))

#define INT(x) ((int)(x))

#define sign(x,y) (((y) >= 0) ? ABS(x) : -ABS(x))
#define SIGN(x,y) (((y) >= 0) ? ABS(x) : -ABS(x))
